#!/usr/bin/env python2.2
# (And yes, it requires 2.2!)
#
# Rizen's AcroBot - Plays Acrophobia in IRC
# Copyright (c) 2002,2003 by Theodore Reed (rizen)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

try:
	from psyco.classes import *
except ImportError:
	pass

import sys, string, random, ircbot, irclib, time, threading
true = 1
false = 0
version = "0.9.3"

# Changelog:
#
# 0.9.3:
#
#     + Added COPYING and copyright statements. (rizen)
#     + Added the ability to use psyco. (rizen)
#

# CONFIGURATION STUFF GOES HERE
acro_time = 90 # Seconds to come up with an acro
vote_time = 45 # Seconds to vote on acros
start_acro= 3  # The number of letters in the first round
rounds    = 5  # Number of rounds (letters in acro goes up once each round
total_weight = 70 # Total weight. If you change one of the weight values, add or subtract this accordingly
weight   = [3, 3, 3, 3, 3, 4, 3, 3, 3, 3, 2, 3, 3, 3, 3, 3, 1, 3, 3, 3, 3, 2, 2, 1, 2, 2]
          # A  B  C  D  E  F  G  H  I  J  K  L  M  N  O  P  Q  R  S  T  U  V  W  X  Y  Z
alphabet = ['A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z']
	   # Weight determines the chance that a certain letter will come up in an acro
	   # The higher the number, the greater chance. Tweak this if difficult letters come up
	   #  too often, etc.
	   # The alphabet prolly doesn't need to be modified, I just put it there because I need such
	   #  an array, and it looked like a good place to put it.
allow_doubles	= true 	# Allow the same letter twice in a row
allow_triples	= false # Allow the same letter three times in a row
servers		= [["cosmos.esper.net", 5555], ["adastra.esper.net", 5555]]
nick		= "AcroBot"
chan		= "#acrophobia"
# END CONFIGURATION

# TODO
# Actuall put in the help handler

class AcroBot(ircbot.SingleServerIRCBot):
	def __init__(self, serverlist, nick, chan):
		print "Rizen's AcroBot, copyright (c) 2002, 2003 by Theodore Reed, is FREE SOFTWARE and is covered by the terms of the GNU GPL. See the file COPYING for details."
		self.me = nick
		self.chan = chan
		
		self.rnd = random.Random(time.time())
		self.mode_switcher = threading.Timer(acro_time, self.switch_mode)
		self.vote_time = threading.Timer(vote_time, self.round)
				
		self.on = false
		self.scores = {}
		self.this_round_nicks = []
		self.this_round_acros = []
		self.voted = []
		self.this_round_scores = []
		self.which_round = 0
		self.acro = ""
		self.mode = ""
		
		ircbot.SingleServerIRCBot.__init__(self, serverlist, nick, "Rizen's AcroBot " + version)
		print "Connecting..."
		
		self.start()
		
	def disconnect(self):
		ircbot.SingleServerIRCBot.disconnect(self, "Rizen's AcroBot " + version)
		print "Disconnecting..."
		sys.exit()
		
	def round(self):
		for n in range(len(self.this_round_nicks)):
			if self.scores.has_key(self.this_round_nicks[n]):
				self.scores[self.this_round_nicks[n]] += self.this_round_scores[n]
			else:
				self.scores[self.this_round_nicks[n]] = self.this_round_scores[n]
					
		self.connection.privmsg(self.chan, "\x02Voting time is up!")
		for n in range(len(self.this_round_nicks)):
			if self.this_round_scores[n] > 0:
				self.connection.privmsg(self.chan, self.this_round_nicks[n] + "'s reponse was '" + self.this_round_acros[n] + "' and got " + str(self.this_round_scores[n]) + " votes!")
		
		if self.which_round == rounds:
			self.endgame()
			return

		self.connection.privmsg(self.chan, "The score stands at:")
		for nick in self.scores.keys():
			if self.scores[nick] > 0:
				self.connection.privmsg(self.chan, nick + " with a score of " + str(self.scores[nick]) + "!")

		self.this_round_nicks = []
		self.this_round_acros = []
		self.voted = []
		self.this_round_scores = []
		
		self.which_round += 1
		self.gen_acro(start_acro + self.which_round - 1)
		self.mode = "ACRO"
		self.connection.privmsg(self.chan, "Round " + str(self.which_round) + "! The new acro is: \x02" + self.acro)
		threading.Timer(acro_time, self.switch_mode).start()
		
	def switch_mode(self):
		self.mode = "VOTE"
		self.connection.privmsg(self.chan, "Acro time is up! Please vote now on the following choices:")
		for a in range(len(self.this_round_acros)):
			self.connection.privmsg(self.chan, "#" + str(a) + ": " + self.this_round_acros[a])
		threading.Timer(vote_time, self.round).start()
		
	def startgame(self):
		self.which_round = 1
		self.on = true
		self.gen_acro(start_acro)
		self.mode = "ACRO"
		self.connection.privmsg(self.chan, "\x02Starting a new game of acrophobia! Get ready!")
		self.connection.privmsg(self.chan, "Round " + str(self.which_round) + "! The new acro is: \x02" + self.acro)
		threading.Timer(acro_time, self.switch_mode).start()
	
	def endgame(self):
		msg = self.connection.privmsg
		msg(self.chan, "\x02The game is over!")
		msg(self.chan, "Ending scores:")
		for nick in self.scores.keys():
			msg(self.chan, nick + " with a score of " + str(self.scores[nick]) + "!")
			
		self.on = false
		self.scores = {}
		self.this_round_nicks = []
		self.this_round_acros = []
		self.voted = []
		self.this_round_scores = []
		self.which_round = 0
		self.acro = ""		
		self.mode = ""
		
	def on_welcome(self, c, e):
		c.join(self.chan)
		c.privmsg(self.chan, "Rizen's AcroBot " + version + "! Distributed under the terms of the GPL. Type \"/msg " + self.me + " !help\" for more information.")
		
	def on_privmsg(self, c, e):
		if string.split(e.arguments()[0])[0] == "!help":
			pass
			#self.help(irclib.nm_to_n(e.source()))
		elif string.split(e.arguments()[0])[0] == "!go":
			self.startgame()
		elif string.split(e.arguments()[0])[0] == "!shutdown":
			self.disconnect()
		elif self.on == false:
			c.privmsg(e.source(), "Sorry, no game is currently running. Try 'help'.")
		elif self.mode == "ACRO":
			if self.confirm_acro(string.split(e.arguments()[0])) == false:
				c.privmsg(irclib.nm_to_n(e.source()), "That does not match the acro. Try again.")
				return
			else:
				if e.arguments()[0] not in self.this_round_acros:
					c.privmsg(irclib.nm_to_n(e.source()), "You've been entered in this round.")
					self.this_round_nicks.append(irclib.nm_to_n(e.source()))
					self.this_round_acros.append(e.arguments()[0])
					self.this_round_scores.append(0)
					return
				else:
					c.privmsg(irclib.nm_to_n(e.source()), "That acro has already been entered. Please try again.")
					return
		elif self.mode == "VOTE":
			try:
				vote = int(string.split(e.arguments()[0])[0])
				if irclib.nm_to_n(e.source()) not in self.this_round_nicks:
					c.privmsg(irclib.nm_to_n(e.source()), "You can't vote if you don't participate.")
					return
				if irclib.nm_to_n(e.source()) == self.this_round_nicks[vote]:
					c.privmsg(irclib.nm_to_n(e.source()), "You can't vote for yourself. Try again.")
					return
				if irclib.nm_to_n(e.source()) not in self.voted:
					self.this_round_scores[vote] += 1
					self.voted.append(irclib.nm_to_n(e.source()))
					c.privmsg(irclib.nm_to_n(e.source()), "Your vote has been counted.")
					return
			except ValueError:
				pass
					
				
	def confirm_acro(self, input):
		if len(input) != len(self.acro):
			return false
		for i in range(len(self.acro)):
			if string.capitalize(input[i])[0] != self.acro[i]:
				return false
		return true
	
	def gen_acro(self, length):
		self.acro = self.random_letter()
		letter = self.random_letter()
		if allow_doubles == false and self.acro[0] == letter:
			while self.acro[0] == letter:
				letter = self.random_letter()
		self.acro += letter
		
		for i in range(2, length):
			letter = self.random_letter()
			if allow_doubles == false and self.acro[i-1] == letter:
				while self.acro[i-1] == letter:
					letter = self.random_letter()
			if allow_triples == false and self.acro[i-1] == letter and self.acro[i-2] == letter:
				while self.acro[i-1] == letter:
					letter = self.random_letter()
			self.acro += letter
				
	def random_letter(self):
		n = self.rnd.randrange(0, total_weight-1)
		for l in range(len(alphabet)):
			if n < weight[l]:
				return alphabet[l]
			else:
				n -= weight[l]
		return alphabet[-1]

AcroBot(servers, nick, chan)
